import groovy.transform.*
@Canonical(excludes="lastName, age")
class Person {
  String firstName
  String lastName
  int age
}

@Immutable
class CreditCard {
  String cardNumber
  int creditLimit
}

@Newify([Person, CreditCard])
def fluentCreate() {
  println Person.new(firstName: "John", lastName: "Doe", age: 20)
  println Person(firstName: "John", lastName: "Doe", age: 20)
  println CreditCard("1234-5678-1234-5678", 2000)
}

fluentCreate()
